# coding: utf-8


"""
IGNORE:
    Nutanix Aiops Versioned APIs

    Manage infrastructure on-premises and in the cloud seamlessly through AIOps features such as Analysis, Reporting, Capacity Planning, What if Analysis, VM Rightsizing, Troubleshooting, App Discovery, Broad Observability, and Ops Automation through Playbooks.  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

class DeprecationModel(object):

    """An abstract representation of an object which has the deprecated information.

    :param deprecated_version: (:attr:`deprecated_version`) Deprecated after the version.
    :type deprecated_version: 
    :param deprecated_date: (:attr:`deprecated_date`) Deprecated after the date.
    :type deprecated_date: 
    :param deprecated_by: (:attr:`deprecated_by`) Represents the deprecation name of the attribute.
    :type deprecated_by: 
    :param deprecated_reason: (:attr:`deprecated_reason`) Represents the reason for the deprecation.
    :type deprecated_reason: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'deprecated_version': 'str',
        'deprecated_date': 'str',
        'deprecated_by': 'str',
        'deprecated_reason': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'deprecated_version': 'deprecatedVersion',
        'deprecated_date': 'deprecatedDate',
        'deprecated_by': 'deprecatedBy',
        'deprecated_reason': 'deprecatedReason',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, deprecated_version=None, deprecated_date=None, deprecated_by=None, deprecated_reason=None, *args, **kwargs):  # noqa: E501
        self.__deprecated_version = None
        self.__deprecated_date = None
        self.__deprecated_by = None
        self.__deprecated_reason = None
        self.discriminator = None
        if deprecated_version is not None:
            self.__deprecated_version = deprecated_version
        if deprecated_date is not None:
            self.__deprecated_date = deprecated_date
        if deprecated_by is not None:
            self.__deprecated_by = deprecated_by
        if deprecated_reason is not None:
            self.__deprecated_reason = deprecated_reason
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'aiops.v4.stats.DeprecationModel'

    def _initialize_fq_object_type(self):
        return 'aiops.v4.r0.a2.stats.DeprecationModel'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def deprecated_version(self):
        """
        Deprecated after the version.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__deprecated_version

    @deprecated_version.setter
    def deprecated_version(self, deprecated_version):

        self.__deprecated_version = deprecated_version

    @property
    def deprecated_date(self):
        """
        Deprecated after the date.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__deprecated_date

    @deprecated_date.setter
    def deprecated_date(self, deprecated_date):

        self.__deprecated_date = deprecated_date

    @property
    def deprecated_by(self):
        """
        Represents the deprecation name of the attribute.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__deprecated_by

    @deprecated_by.setter
    def deprecated_by(self, deprecated_by):

        self.__deprecated_by = deprecated_by

    @property
    def deprecated_reason(self):
        """
        Represents the reason for the deprecation.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__deprecated_reason

    @deprecated_reason.setter
    def deprecated_reason(self, deprecated_reason):

        self.__deprecated_reason = deprecated_reason

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DeprecationModel, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeprecationModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

